#include "lowlevel.h"
#include "highlevel.h"

void LCD_icon (unsigned char * __code imgdata,unsigned char x, unsigned char page,unsigned char width, unsigned char height)
{
unsigned char bytes,row;

	while(height--) {                       // para cada fila
	  bytes=width;                          // bytes a enviar por fila
	  row=x;                                // posicion de inicio en la fila
	  LCD_SelSide(x>63);			// 0-63 => side 0; 63>127 => side 1
	  x=(x>63)?(x-64):x;			// corrige x si x >63
	  LCD_WriteCmd (0x40+x);		// address = x o x-64
	  LCD_WriteCmd (0xB8+page);		// page address	
	  while(bytes--) {
		LCD_WriteData(*(imgdata++));	// datos
		if(++row==64) {                 // cambio de controlador ?
		  row=0;                        // corrige columna
		  LCD_SelSide(1);		// controlador derecho
		  LCD_WriteCmd (0x40);		// address = 0
		  LCD_WriteCmd (0xB8+page);	// page address
		}
	  }
	  page++;
	}
}

void LCD_area (unsigned char pattern,unsigned char x, unsigned char page,unsigned char width, unsigned char height)
{
unsigned char bytes,row;

	while(height--) {                       // para cada fila
	  bytes=width;                          // bytes a enviar por fila
	  row=x;                                // posicion de inicio en la fila
	  LCD_SelSide(x>63);			// 0-63 => side 0; 63>127 => side 1
	  x=(x>63)?(x-64):x;			// corrige x si x >63
	  LCD_WriteCmd (0x40+x);		// address = x o x-64
	  LCD_WriteCmd (0xB8+page);		// page address	
	  while(bytes--) {
		LCD_WriteData(pattern);	        // datos
		if(++row==64) {                 // cambio de controlador ?
		  row=0;                        // corrige columna
		  LCD_SelSide(1);		// controlador derecho
		  LCD_WriteCmd (0x40);		// address = 0
		  LCD_WriteCmd (0xB8+page);	// page address
		}
	  }
	  page++;
	}
}

void LCD_invert (unsigned char x, unsigned char page,unsigned char width)
{
unsigned char bytes,row,dat;

	  bytes=width;                          // bytes a enviar por fila
	  LCD_SelSide(x>63);			// 0-63 => side 0; 63>127 => side 1
	  x=(x>63)?(x-64):x;			// corrige x si x >63
	  LCD_WriteCmd (0x40+x);		// address = x o x-64
	  LCD_WriteCmd (0xB8+page);		// page address	
	  row=x;                                // posicion de inicio en la fila
	  while(bytes--) {
	    LCD_ReadData();					// dummy read after address setting
	    dat=LCD_ReadData();				// get data at that address
	    dat^=0xFF;                          // invert
	    LCD_WriteCmd (0x40+row);				// set address again (reading increments counter)
	    LCD_WriteData(dat);	        // datos
	    if(++row==64) {                 // cambio de controlador ?
	      row=0;                        // corrige columna
	      LCD_SelSide(1);		// controlador derecho
	      LCD_WriteCmd (0x40);		// address = 0
	      LCD_WriteCmd (0xB8+page);	// page address
	    }
	  }
}
